﻿using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Numerics;
using Zcu.Mve.Visualization;

namespace Zcu.Mve.Compression
{
    /// <summary>
    /// Outputs the length of the input array.
    /// </summary>
    [ModuleInfo("Oldřich Petřík", "Outputs the length of the input array", CategoryType.Generic, CategoryData.Generic)]
    [PortInfo("Array", "Input array.")]
    [PortInfo("Length", "The length of the array.")]
    public class ArrayLength : Module
    {
        private Integer _res = new Integer(-1);

        /// <summary>
        /// ArrayLength constructor.
        /// </summary>
        public ArrayLength()
        {
            AddInPort("Array", typeof(UniformDataArray));
            AddOutPort("Length", typeof(Integer));
        }

        ///<inheritdoc />
        public override void Execute()
        {
            if (_res.Value < 0 && IsAllDataSame() && IsAllUserSettingsSame())
            {
                SetOutput("Length", _res, true);
            }
            else
            {
                UniformDataArray array = (UniformDataArray)GetInput("Array");
                _res.Value = array.Count;
                SetOutput("Length", _res, false);
            }
        }
    }
}
