﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Zcu.Mve.Compression
{

    /// <summary>
    /// Data of topology events for Edgebreaker
    /// </summary>
    public class TopologyEventData : EventArgs
    {
        private int corner = -1; //actual corner to predict
        private int opositeCorner = -1; //actual oposite corner
        private int leftCorner = -1; //actual corner on the left, clockwise from "opositeCorner" to "corner"
        private int rightCorner = -1; //actual corner on the right, clockwise from "opositeCorner" to "corner"

        /// <summary>
        /// Index of corner we want to predict
        /// </summary>
        public int CornerVertexIndex
        {
            set
            {
                corner = value;
            }

            get
            {
                return corner;
            }
        }

        /// <summary>
        /// Index of oposite corner to the corner we want to predict
        /// </summary>
        public int OpositeCornerVertexIndex
        {
            set
            {
                opositeCorner = value;
            }

            get
            {
                return opositeCorner;
            }
        }

        /// <summary>
        /// Corner on the left, clockwise from "opositeCorner" to "corner"
        /// </summary>
        public int LeftCornerVertexIndex
        {
            set
            {
                leftCorner = value;
            }

            get
            {
                return leftCorner;
            }
        }

        /// <summary>
        /// Corner on the right, clockwise from "opositeCorner" to "corner"
        /// </summary>
        public int RightCornerVertexIndex
        {
            set
            {
                rightCorner = value;
            }

            get
            {
                return rightCorner;
            }
        }
    }

    /// <summary>
    /// Data for progress events
    /// </summary>
    public class ProgressEventData : EventArgs
    {
        private float progress; // progress value

        /// <summary>
        /// Progress value
        /// </summary>
        public float Progress
        {
            set
            {
                progress = value;
            }

            get
            {
                return progress;
            }
        }
    }
}
